<html>
<head>
<title>OGRE: OgreVector4.h Source File - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.5.3 -->
<div class="tabs">
  <ul>
    <li><a href="index.html"><span>Main&nbsp;Page</span></a></li>
    <li><a href="namespaces.html"><span>Namespaces</span></a></li>
    <li><a href="classes.html"><span>Classes</span></a></li>
    <li class="current"><a href="files.html"><span>Files</span></a></li>
    <li><a href="dirs.html"><span>Directories</span></a></li>
    <li><a href="pages.html"><span>Related&nbsp;Pages</span></a></li>
  </ul>
</div>
<div class="nav">
<a class="el" href="dir_d6c9b501d36b850bf0bac687671293db.html">OgreMain</a>&nbsp;&raquo&nbsp;<a class="el" href="dir_f35e1e76cd4423745a1cccb1f171d4e3.html">include</a></div>
<h1>OgreVector4.h</h1><a href="OgreVector4_8h.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00003"></a>00003 <span class="comment">This source file is part of OGRE</span>
<a name="l00004"></a>00004 <span class="comment">    (Object-oriented Graphics Rendering Engine)</span>
<a name="l00005"></a>00005 <span class="comment">For the latest info, see http://www.ogre3d.org/</span>
<a name="l00006"></a>00006 <span class="comment"></span>
<a name="l00007"></a>00007 <span class="comment">Copyright (c) 2000-2006 Torus Knot Software Ltd</span>
<a name="l00008"></a>00008 <span class="comment">Also see acknowledgements in Readme.html</span>
<a name="l00009"></a>00009 <span class="comment"></span>
<a name="l00010"></a>00010 <span class="comment">This program is free software; you can redistribute it and/or modify it under</span>
<a name="l00011"></a>00011 <span class="comment">the terms of the GNU Lesser General Public License as published by the Free Software</span>
<a name="l00012"></a>00012 <span class="comment">Foundation; either version 2 of the License, or (at your option) any later</span>
<a name="l00013"></a>00013 <span class="comment">version.</span>
<a name="l00014"></a>00014 <span class="comment"></span>
<a name="l00015"></a>00015 <span class="comment">This program is distributed in the hope that it will be useful, but WITHOUT</span>
<a name="l00016"></a>00016 <span class="comment">ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS</span>
<a name="l00017"></a>00017 <span class="comment">FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more details.</span>
<a name="l00018"></a>00018 <span class="comment"></span>
<a name="l00019"></a>00019 <span class="comment">You should have received a copy of the GNU Lesser General Public License along with</span>
<a name="l00020"></a>00020 <span class="comment">this program; if not, write to the Free Software Foundation, Inc., 59 Temple</span>
<a name="l00021"></a>00021 <span class="comment">Place - Suite 330, Boston, MA 02111-1307, USA, or go to</span>
<a name="l00022"></a>00022 <span class="comment">http://www.gnu.org/copyleft/lesser.txt.</span>
<a name="l00023"></a>00023 <span class="comment"></span>
<a name="l00024"></a>00024 <span class="comment">You may alternatively use this source under the terms of a specific version of</span>
<a name="l00025"></a>00025 <span class="comment">the OGRE Unrestricted License provided you have obtained such a license from</span>
<a name="l00026"></a>00026 <span class="comment">Torus Knot Software Ltd.</span>
<a name="l00027"></a>00027 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00028"></a>00028 <span class="comment">*/</span>
<a name="l00029"></a>00029 <span class="preprocessor">#ifndef __Vector4_H__</span>
<a name="l00030"></a>00030 <span class="preprocessor"></span><span class="preprocessor">#define __Vector4_H__</span>
<a name="l00031"></a>00031 <span class="preprocessor"></span>
<a name="l00032"></a>00032 <span class="preprocessor">#include "<a class="code" href="OgrePrerequisites_8h.html">OgrePrerequisites.h</a>"</span>
<a name="l00033"></a>00033 <span class="preprocessor">#include "<a class="code" href="OgreVector3_8h.html">OgreVector3.h</a>"</span>
<a name="l00034"></a>00034 
<a name="l00035"></a>00035 <span class="keyword">namespace </span>Ogre
<a name="l00036"></a>00036 {
<a name="l00037"></a>00037 
<a name="l00040"></a><a class="code" href="classOgre_1_1Vector4.html">00040</a>     <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#20566b1253bae200372ed9162489a663">_OgreExport</a> <a class="code" href="classOgre_1_1Vector4.html" title="4-dimensional homogenous vector.">Vector4</a>
<a name="l00041"></a>00041     {
<a name="l00042"></a>00042     <span class="keyword">public</span>:
<a name="l00043"></a><a class="code" href="classOgre_1_1Vector4.html#389cf99ed365e8ec1d823c0a0cf52da3">00043</a>         <a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> x, y, z, w;
<a name="l00044"></a>00044 
<a name="l00045"></a>00045     <span class="keyword">public</span>:
<a name="l00046"></a><a class="code" href="classOgre_1_1Vector4.html#e4417c4a3d52ee6fafd4a9103343958c">00046</a>         <span class="keyword">inline</span> <a class="code" href="classOgre_1_1Vector4.html" title="4-dimensional homogenous vector.">Vector4</a>()
<a name="l00047"></a>00047         {
<a name="l00048"></a>00048         }
<a name="l00049"></a>00049 
<a name="l00050"></a><a class="code" href="classOgre_1_1Vector4.html#75b3e58bb0eccad1c21b68958a33a9fc">00050</a>         <span class="keyword">inline</span> <a class="code" href="classOgre_1_1Vector4.html" title="4-dimensional homogenous vector.">Vector4</a>( <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> fX, <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> fY, <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> fZ, <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> fW )
<a name="l00051"></a>00051             : x( fX ), y( fY ), z( fZ ), w( fW)
<a name="l00052"></a>00052         {
<a name="l00053"></a>00053         }
<a name="l00054"></a>00054 
<a name="l00055"></a><a class="code" href="classOgre_1_1Vector4.html#2e8dae854a7801e2aaa97bbed0b27374">00055</a>         <span class="keyword">inline</span> <span class="keyword">explicit</span> <a class="code" href="classOgre_1_1Vector4.html" title="4-dimensional homogenous vector.">Vector4</a>( <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> afCoordinate[4] )
<a name="l00056"></a>00056             : x( afCoordinate[0] ),
<a name="l00057"></a>00057               y( afCoordinate[1] ),
<a name="l00058"></a>00058               z( afCoordinate[2] ),
<a name="l00059"></a>00059               w( afCoordinate[3] )
<a name="l00060"></a>00060         {
<a name="l00061"></a>00061         }
<a name="l00062"></a>00062 
<a name="l00063"></a><a class="code" href="classOgre_1_1Vector4.html#7da09ff768d847f015f3b1b9830a8043">00063</a>         <span class="keyword">inline</span> <span class="keyword">explicit</span> <a class="code" href="classOgre_1_1Vector4.html" title="4-dimensional homogenous vector.">Vector4</a>( <span class="keyword">const</span> <span class="keywordtype">int</span> afCoordinate[4] )
<a name="l00064"></a>00064         {
<a name="l00065"></a>00065             x = (<a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a>)afCoordinate[0];
<a name="l00066"></a>00066             y = (<a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a>)afCoordinate[1];
<a name="l00067"></a>00067             z = (<a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a>)afCoordinate[2];
<a name="l00068"></a>00068             w = (<a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a>)afCoordinate[3];
<a name="l00069"></a>00069         }
<a name="l00070"></a>00070 
<a name="l00071"></a><a class="code" href="classOgre_1_1Vector4.html#9d6cc1b910cf8d738b306995f3b442d4">00071</a>         <span class="keyword">inline</span> <span class="keyword">explicit</span> <a class="code" href="classOgre_1_1Vector4.html" title="4-dimensional homogenous vector.">Vector4</a>( <a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a>* <span class="keyword">const</span> r )
<a name="l00072"></a>00072             : x( r[0] ), y( r[1] ), z( r[2] ), w( r[3] )
<a name="l00073"></a>00073         {
<a name="l00074"></a>00074         }
<a name="l00075"></a>00075 
<a name="l00076"></a><a class="code" href="classOgre_1_1Vector4.html#da9aac749e3d93a83a0e1bb67f3a091f">00076</a>         <span class="keyword">inline</span> <span class="keyword">explicit</span> <a class="code" href="classOgre_1_1Vector4.html" title="4-dimensional homogenous vector.">Vector4</a>( <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> scaler )
<a name="l00077"></a>00077             : x( scaler )
<a name="l00078"></a>00078             , y( scaler )
<a name="l00079"></a>00079             , z( scaler )
<a name="l00080"></a>00080             , w( scaler )
<a name="l00081"></a>00081         {
<a name="l00082"></a>00082         }
<a name="l00083"></a>00083 
<a name="l00084"></a><a class="code" href="classOgre_1_1Vector4.html#019e80f62dd12ea37b27b2d2a05aed64">00084</a>         <span class="keyword">inline</span> <span class="keyword">explicit</span> <a class="code" href="classOgre_1_1Vector4.html" title="4-dimensional homogenous vector.">Vector4</a>(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; rhs)
<a name="l00085"></a>00085             : x(rhs.x), y(rhs.y), z(rhs.z), w(1.0f)
<a name="l00086"></a>00086         {
<a name="l00087"></a>00087         }
<a name="l00088"></a>00088 
<a name="l00089"></a><a class="code" href="classOgre_1_1Vector4.html#4666b1e5c544038aaaf852ab2f200718">00089</a>         <span class="keyword">inline</span> <a class="code" href="classOgre_1_1Vector4.html" title="4-dimensional homogenous vector.">Vector4</a>( <span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector4.html" title="4-dimensional homogenous vector.">Vector4</a>&amp; rkVector )
<a name="l00090"></a>00090             : x( rkVector.x ), y( rkVector.y ), z( rkVector.z ), w (rkVector.w)
<a name="l00091"></a>00091         {
<a name="l00092"></a>00092         }
<a name="l00093"></a>00093 
<a name="l00094"></a><a class="code" href="classOgre_1_1Vector4.html#a55187a08d385c6c367cc16338ad23ce">00094</a>         <span class="keyword">inline</span> <a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> operator [] ( <span class="keyword">const</span> <span class="keywordtype">size_t</span> i )<span class="keyword"> const</span>
<a name="l00095"></a>00095 <span class="keyword">        </span>{
<a name="l00096"></a>00096             assert( i &lt; 4 );
<a name="l00097"></a>00097 
<a name="l00098"></a>00098             <span class="keywordflow">return</span> *(&amp;x+i);
<a name="l00099"></a>00099         }
<a name="l00100"></a>00100 
<a name="l00101"></a><a class="code" href="classOgre_1_1Vector4.html#96b4c5c76a199850c8c4e61be0feed7d">00101</a>         <span class="keyword">inline</span> <a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a>&amp; operator [] ( <span class="keyword">const</span> <span class="keywordtype">size_t</span> i )
<a name="l00102"></a>00102         {
<a name="l00103"></a>00103             assert( i &lt; 4 );
<a name="l00104"></a>00104 
<a name="l00105"></a>00105             <span class="keywordflow">return</span> *(&amp;x+i);
<a name="l00106"></a>00106         }
<a name="l00107"></a>00107 
<a name="l00109"></a><a class="code" href="classOgre_1_1Vector4.html#e8a0fc61bcae1449c843b3c5430cef1f">00109</a>         <span class="keyword">inline</span> <a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a>* ptr()
<a name="l00110"></a>00110         {
<a name="l00111"></a>00111             <span class="keywordflow">return</span> &amp;x;
<a name="l00112"></a>00112         }
<a name="l00114"></a><a class="code" href="classOgre_1_1Vector4.html#641d847ad0e066e213db1e1dadf43cee">00114</a>         <span class="keyword">inline</span> <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a>* ptr()<span class="keyword"> const</span>
<a name="l00115"></a>00115 <span class="keyword">        </span>{
<a name="l00116"></a>00116             <span class="keywordflow">return</span> &amp;x;
<a name="l00117"></a>00117         }
<a name="l00118"></a>00118 
<a name="l00123"></a><a class="code" href="classOgre_1_1Vector4.html#465dfb677017e546628f87470d6dbcd6">00123</a>         <span class="keyword">inline</span> <a class="code" href="classOgre_1_1Vector4.html" title="4-dimensional homogenous vector.">Vector4</a>&amp; operator = ( <span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector4.html" title="4-dimensional homogenous vector.">Vector4</a>&amp; rkVector )
<a name="l00124"></a>00124         {
<a name="l00125"></a>00125             x = rkVector.<a class="code" href="classOgre_1_1Vector4.html#c1f14b711795b4d13140e992d9a3e6cf">x</a>;
<a name="l00126"></a>00126             y = rkVector.<a class="code" href="classOgre_1_1Vector4.html#4a55a790632b60df0f536efa68de3bfa">y</a>;
<a name="l00127"></a>00127             z = rkVector.<a class="code" href="classOgre_1_1Vector4.html#389cf99ed365e8ec1d823c0a0cf52da3">z</a>;
<a name="l00128"></a>00128             w = rkVector.<a class="code" href="classOgre_1_1Vector4.html#601896b4f2f5be1d7ccd0ee4a0500237">w</a>;
<a name="l00129"></a>00129 
<a name="l00130"></a>00130             <span class="keywordflow">return</span> *<span class="keyword">this</span>;
<a name="l00131"></a>00131         }
<a name="l00132"></a>00132 
<a name="l00133"></a><a class="code" href="classOgre_1_1Vector4.html#69daa0f94cfeb2c725521b1672204bf7">00133</a>         <span class="keyword">inline</span> <a class="code" href="classOgre_1_1Vector4.html" title="4-dimensional homogenous vector.">Vector4</a>&amp; operator = ( <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> fScalar)
<a name="l00134"></a>00134         {
<a name="l00135"></a>00135             x = fScalar;
<a name="l00136"></a>00136             y = fScalar;
<a name="l00137"></a>00137             z = fScalar;
<a name="l00138"></a>00138             w = fScalar;
<a name="l00139"></a>00139             <span class="keywordflow">return</span> *<span class="keyword">this</span>;
<a name="l00140"></a>00140         }
<a name="l00141"></a>00141 
<a name="l00142"></a><a class="code" href="classOgre_1_1Vector4.html#e7f48d8e2036594f4d65e2dca9fe286a">00142</a>         <span class="keyword">inline</span> <span class="keywordtype">bool</span> <a class="code" href="namespaceOgre.html#b426b0250db523190d60f4bfe0414499">operator == </a>( <span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector4.html" title="4-dimensional homogenous vector.">Vector4</a>&amp; rkVector )<span class="keyword"> const</span>
<a name="l00143"></a>00143 <span class="keyword">        </span>{
<a name="l00144"></a>00144             <span class="keywordflow">return</span> ( x == rkVector.<a class="code" href="classOgre_1_1Vector4.html#c1f14b711795b4d13140e992d9a3e6cf">x</a> &amp;&amp;
<a name="l00145"></a>00145                 y == rkVector.<a class="code" href="classOgre_1_1Vector4.html#4a55a790632b60df0f536efa68de3bfa">y</a> &amp;&amp;
<a name="l00146"></a>00146                 z == rkVector.<a class="code" href="classOgre_1_1Vector4.html#389cf99ed365e8ec1d823c0a0cf52da3">z</a> &amp;&amp;
<a name="l00147"></a>00147                 w == rkVector.<a class="code" href="classOgre_1_1Vector4.html#601896b4f2f5be1d7ccd0ee4a0500237">w</a> );
<a name="l00148"></a>00148         }
<a name="l00149"></a>00149 
<a name="l00150"></a><a class="code" href="classOgre_1_1Vector4.html#0aa33b3bb9f3b8b8ef7037eaf43bedc8">00150</a>         <span class="keyword">inline</span> <span class="keywordtype">bool</span> <a class="code" href="namespaceOgre.html#9d8174300d9fd7b766d727c85e11a20f">operator != </a>( <span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector4.html" title="4-dimensional homogenous vector.">Vector4</a>&amp; rkVector )<span class="keyword"> const</span>
<a name="l00151"></a>00151 <span class="keyword">        </span>{
<a name="l00152"></a>00152             <span class="keywordflow">return</span> ( x != rkVector.<a class="code" href="classOgre_1_1Vector4.html#c1f14b711795b4d13140e992d9a3e6cf">x</a> ||
<a name="l00153"></a>00153                 y != rkVector.<a class="code" href="classOgre_1_1Vector4.html#4a55a790632b60df0f536efa68de3bfa">y</a> ||
<a name="l00154"></a>00154                 z != rkVector.<a class="code" href="classOgre_1_1Vector4.html#389cf99ed365e8ec1d823c0a0cf52da3">z</a> ||
<a name="l00155"></a>00155                 w != rkVector.<a class="code" href="classOgre_1_1Vector4.html#601896b4f2f5be1d7ccd0ee4a0500237">w</a> );
<a name="l00156"></a>00156         }
<a name="l00157"></a>00157 
<a name="l00158"></a><a class="code" href="classOgre_1_1Vector4.html#59f17a6c7980f16a571f535b2c47a8fc">00158</a>         <span class="keyword">inline</span> <a class="code" href="classOgre_1_1Vector4.html" title="4-dimensional homogenous vector.">Vector4</a>&amp; operator = (<span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; rhs)
<a name="l00159"></a>00159         {
<a name="l00160"></a>00160             x = rhs.<a class="code" href="classOgre_1_1Vector3.html#27be092ad0b7e0504ddf4db5cd565f14">x</a>;
<a name="l00161"></a>00161             y = rhs.<a class="code" href="classOgre_1_1Vector3.html#05ca4492ce30a049ae4102e3f5e85aff">y</a>;
<a name="l00162"></a>00162             z = rhs.<a class="code" href="classOgre_1_1Vector3.html#b1f9e7702256f32156be4d7e0fdafd7e">z</a>;
<a name="l00163"></a>00163             w = 1.0f;
<a name="l00164"></a>00164             <span class="keywordflow">return</span> *<span class="keyword">this</span>;
<a name="l00165"></a>00165         }
<a name="l00166"></a>00166 
<a name="l00167"></a>00167         <span class="comment">// arithmetic operations</span>
<a name="l00168"></a><a class="code" href="classOgre_1_1Vector4.html#0b8c03743d6b8f72149f914f03998689">00168</a>         <span class="keyword">inline</span> <a class="code" href="classOgre_1_1Vector4.html" title="4-dimensional homogenous vector.">Vector4</a> operator + ( <span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector4.html" title="4-dimensional homogenous vector.">Vector4</a>&amp; rkVector )<span class="keyword"> const</span>
<a name="l00169"></a>00169 <span class="keyword">        </span>{
<a name="l00170"></a>00170             <span class="keywordflow">return</span> <a class="code" href="classOgre_1_1Vector4.html" title="4-dimensional homogenous vector.">Vector4</a>(
<a name="l00171"></a>00171                 x + rkVector.<a class="code" href="classOgre_1_1Vector4.html#c1f14b711795b4d13140e992d9a3e6cf">x</a>,
<a name="l00172"></a>00172                 y + rkVector.<a class="code" href="classOgre_1_1Vector4.html#4a55a790632b60df0f536efa68de3bfa">y</a>,
<a name="l00173"></a>00173                 z + rkVector.<a class="code" href="classOgre_1_1Vector4.html#389cf99ed365e8ec1d823c0a0cf52da3">z</a>,
<a name="l00174"></a>00174                 w + rkVector.<a class="code" href="classOgre_1_1Vector4.html#601896b4f2f5be1d7ccd0ee4a0500237">w</a>);
<a name="l00175"></a>00175         }
<a name="l00176"></a>00176 
<a name="l00177"></a><a class="code" href="classOgre_1_1Vector4.html#78b1555cd0ea1bcd609086003444e614">00177</a>         <span class="keyword">inline</span> <a class="code" href="classOgre_1_1Vector4.html" title="4-dimensional homogenous vector.">Vector4</a> operator - ( <span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector4.html" title="4-dimensional homogenous vector.">Vector4</a>&amp; rkVector )<span class="keyword"> const</span>
<a name="l00178"></a>00178 <span class="keyword">        </span>{
<a name="l00179"></a>00179             <span class="keywordflow">return</span> <a class="code" href="classOgre_1_1Vector4.html" title="4-dimensional homogenous vector.">Vector4</a>(
<a name="l00180"></a>00180                 x - rkVector.<a class="code" href="classOgre_1_1Vector4.html#c1f14b711795b4d13140e992d9a3e6cf">x</a>,
<a name="l00181"></a>00181                 y - rkVector.<a class="code" href="classOgre_1_1Vector4.html#4a55a790632b60df0f536efa68de3bfa">y</a>,
<a name="l00182"></a>00182                 z - rkVector.<a class="code" href="classOgre_1_1Vector4.html#389cf99ed365e8ec1d823c0a0cf52da3">z</a>,
<a name="l00183"></a>00183                 w - rkVector.<a class="code" href="classOgre_1_1Vector4.html#601896b4f2f5be1d7ccd0ee4a0500237">w</a>);
<a name="l00184"></a>00184         }
<a name="l00185"></a>00185 
<a name="l00186"></a><a class="code" href="classOgre_1_1Vector4.html#bc543c3d85c79acd14dcc530584d1d65">00186</a>         <span class="keyword">inline</span> <a class="code" href="classOgre_1_1Vector4.html" title="4-dimensional homogenous vector.">Vector4</a> <a class="code" href="namespaceOgre.html#8c1aea4f2e6336301a39efede7ef553b">operator * </a>( <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> fScalar )<span class="keyword"> const</span>
<a name="l00187"></a>00187 <span class="keyword">        </span>{
<a name="l00188"></a>00188             <span class="keywordflow">return</span> <a class="code" href="classOgre_1_1Vector4.html" title="4-dimensional homogenous vector.">Vector4</a>(
<a name="l00189"></a>00189                 x * fScalar,
<a name="l00190"></a>00190                 y * fScalar,
<a name="l00191"></a>00191                 z * fScalar,
<a name="l00192"></a>00192                 w * fScalar);
<a name="l00193"></a>00193         }
<a name="l00194"></a>00194 
<a name="l00195"></a><a class="code" href="classOgre_1_1Vector4.html#df1eb823c5225d8f24ced8a8bad10a84">00195</a>         <span class="keyword">inline</span> <a class="code" href="classOgre_1_1Vector4.html" title="4-dimensional homogenous vector.">Vector4</a> <a class="code" href="namespaceOgre.html#8c1aea4f2e6336301a39efede7ef553b">operator * </a>( <span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector4.html" title="4-dimensional homogenous vector.">Vector4</a>&amp; rhs)<span class="keyword"> const</span>
<a name="l00196"></a>00196 <span class="keyword">        </span>{
<a name="l00197"></a>00197             <span class="keywordflow">return</span> <a class="code" href="classOgre_1_1Vector4.html" title="4-dimensional homogenous vector.">Vector4</a>(
<a name="l00198"></a>00198                 rhs.<a class="code" href="classOgre_1_1Vector4.html#c1f14b711795b4d13140e992d9a3e6cf">x</a> * x,
<a name="l00199"></a>00199                 rhs.<a class="code" href="classOgre_1_1Vector4.html#4a55a790632b60df0f536efa68de3bfa">y</a> * y,
<a name="l00200"></a>00200                 rhs.<a class="code" href="classOgre_1_1Vector4.html#389cf99ed365e8ec1d823c0a0cf52da3">z</a> * z,
<a name="l00201"></a>00201                 rhs.<a class="code" href="classOgre_1_1Vector4.html#601896b4f2f5be1d7ccd0ee4a0500237">w</a> * w);
<a name="l00202"></a>00202         }
<a name="l00203"></a>00203 
<a name="l00204"></a><a class="code" href="classOgre_1_1Vector4.html#fd54901fd7d3379584d0abd73a455518">00204</a>         <span class="keyword">inline</span> <a class="code" href="classOgre_1_1Vector4.html" title="4-dimensional homogenous vector.">Vector4</a> <a class="code" href="namespaceOgre.html#49268a0dd483041451c010eeec55f83a">operator / </a>( <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> fScalar )<span class="keyword"> const</span>
<a name="l00205"></a>00205 <span class="keyword">        </span>{
<a name="l00206"></a>00206             assert( fScalar != 0.0 );
<a name="l00207"></a>00207 
<a name="l00208"></a>00208             <a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> fInv = 1.0 / fScalar;
<a name="l00209"></a>00209 
<a name="l00210"></a>00210             <span class="keywordflow">return</span> <a class="code" href="classOgre_1_1Vector4.html" title="4-dimensional homogenous vector.">Vector4</a>(
<a name="l00211"></a>00211                 x * fInv,
<a name="l00212"></a>00212                 y * fInv,
<a name="l00213"></a>00213                 z * fInv,
<a name="l00214"></a>00214                 w * fInv);
<a name="l00215"></a>00215         }
<a name="l00216"></a>00216 
<a name="l00217"></a><a class="code" href="classOgre_1_1Vector4.html#50d14c785b00d8afbd124ffd0e9f0df5">00217</a>         <span class="keyword">inline</span> <a class="code" href="classOgre_1_1Vector4.html" title="4-dimensional homogenous vector.">Vector4</a> <a class="code" href="namespaceOgre.html#49268a0dd483041451c010eeec55f83a">operator / </a>( <span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector4.html" title="4-dimensional homogenous vector.">Vector4</a>&amp; rhs)<span class="keyword"> const</span>
<a name="l00218"></a>00218 <span class="keyword">        </span>{
<a name="l00219"></a>00219             <span class="keywordflow">return</span> <a class="code" href="classOgre_1_1Vector4.html" title="4-dimensional homogenous vector.">Vector4</a>(
<a name="l00220"></a>00220                 x / rhs.<a class="code" href="classOgre_1_1Vector4.html#c1f14b711795b4d13140e992d9a3e6cf">x</a>,
<a name="l00221"></a>00221                 y / rhs.<a class="code" href="classOgre_1_1Vector4.html#4a55a790632b60df0f536efa68de3bfa">y</a>,
<a name="l00222"></a>00222                 z / rhs.<a class="code" href="classOgre_1_1Vector4.html#389cf99ed365e8ec1d823c0a0cf52da3">z</a>,
<a name="l00223"></a>00223                 w / rhs.<a class="code" href="classOgre_1_1Vector4.html#601896b4f2f5be1d7ccd0ee4a0500237">w</a>);
<a name="l00224"></a>00224         }
<a name="l00225"></a>00225 
<a name="l00226"></a><a class="code" href="classOgre_1_1Vector4.html#785f4ea68705fdcca1dca8f09d4e1525">00226</a>         <span class="keyword">inline</span> <span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector4.html" title="4-dimensional homogenous vector.">Vector4</a>&amp; operator + ()<span class="keyword"> const</span>
<a name="l00227"></a>00227 <span class="keyword">        </span>{
<a name="l00228"></a>00228             <span class="keywordflow">return</span> *<span class="keyword">this</span>;
<a name="l00229"></a>00229         }
<a name="l00230"></a>00230 
<a name="l00231"></a><a class="code" href="classOgre_1_1Vector4.html#2123966b60d70dd14e7d165cbb47dba8">00231</a>         <span class="keyword">inline</span> <a class="code" href="classOgre_1_1Vector4.html" title="4-dimensional homogenous vector.">Vector4</a> operator - ()<span class="keyword"> const</span>
<a name="l00232"></a>00232 <span class="keyword">        </span>{
<a name="l00233"></a>00233             <span class="keywordflow">return</span> <a class="code" href="classOgre_1_1Vector4.html" title="4-dimensional homogenous vector.">Vector4</a>(-x, -y, -z, -w);
<a name="l00234"></a>00234         }
<a name="l00235"></a>00235 
<a name="l00236"></a><a class="code" href="classOgre_1_1Vector4.html#691bcd13bad0bf3709ddb010cf57d822">00236</a>         <span class="keyword">inline</span> <span class="keyword">friend</span> <a class="code" href="classOgre_1_1Vector4.html" title="4-dimensional homogenous vector.">Vector4</a> <a class="code" href="namespaceOgre.html#8c1aea4f2e6336301a39efede7ef553b">operator * </a>( <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> fScalar, <span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector4.html" title="4-dimensional homogenous vector.">Vector4</a>&amp; rkVector )
<a name="l00237"></a>00237         {
<a name="l00238"></a>00238             <span class="keywordflow">return</span> <a class="code" href="classOgre_1_1Vector4.html" title="4-dimensional homogenous vector.">Vector4</a>(
<a name="l00239"></a>00239                 fScalar * rkVector.<a class="code" href="classOgre_1_1Vector4.html#c1f14b711795b4d13140e992d9a3e6cf">x</a>,
<a name="l00240"></a>00240                 fScalar * rkVector.<a class="code" href="classOgre_1_1Vector4.html#4a55a790632b60df0f536efa68de3bfa">y</a>,
<a name="l00241"></a>00241                 fScalar * rkVector.<a class="code" href="classOgre_1_1Vector4.html#389cf99ed365e8ec1d823c0a0cf52da3">z</a>,
<a name="l00242"></a>00242                 fScalar * rkVector.<a class="code" href="classOgre_1_1Vector4.html#601896b4f2f5be1d7ccd0ee4a0500237">w</a>);
<a name="l00243"></a>00243         }
<a name="l00244"></a>00244 
<a name="l00245"></a><a class="code" href="classOgre_1_1Vector4.html#2dd10da814b39dc369ac4f96d0055a54">00245</a>         <span class="keyword">inline</span> <span class="keyword">friend</span> <a class="code" href="classOgre_1_1Vector4.html" title="4-dimensional homogenous vector.">Vector4</a> <a class="code" href="namespaceOgre.html#49268a0dd483041451c010eeec55f83a">operator / </a>( <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> fScalar, <span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector4.html" title="4-dimensional homogenous vector.">Vector4</a>&amp; rkVector )
<a name="l00246"></a>00246         {
<a name="l00247"></a>00247             <span class="keywordflow">return</span> <a class="code" href="classOgre_1_1Vector4.html" title="4-dimensional homogenous vector.">Vector4</a>(
<a name="l00248"></a>00248                 fScalar / rkVector.<a class="code" href="classOgre_1_1Vector4.html#c1f14b711795b4d13140e992d9a3e6cf">x</a>,
<a name="l00249"></a>00249                 fScalar / rkVector.<a class="code" href="classOgre_1_1Vector4.html#4a55a790632b60df0f536efa68de3bfa">y</a>,
<a name="l00250"></a>00250                 fScalar / rkVector.<a class="code" href="classOgre_1_1Vector4.html#389cf99ed365e8ec1d823c0a0cf52da3">z</a>,
<a name="l00251"></a>00251                 fScalar / rkVector.<a class="code" href="classOgre_1_1Vector4.html#601896b4f2f5be1d7ccd0ee4a0500237">w</a>);
<a name="l00252"></a>00252         }
<a name="l00253"></a>00253 
<a name="l00254"></a><a class="code" href="classOgre_1_1Vector4.html#28efcff06858b5011bbc4250230539f0">00254</a>         <span class="keyword">inline</span> <span class="keyword">friend</span> <a class="code" href="classOgre_1_1Vector4.html" title="4-dimensional homogenous vector.">Vector4</a> operator + (<span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector4.html" title="4-dimensional homogenous vector.">Vector4</a>&amp; lhs, <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> rhs)
<a name="l00255"></a>00255         {
<a name="l00256"></a>00256             <span class="keywordflow">return</span> <a class="code" href="classOgre_1_1Vector4.html" title="4-dimensional homogenous vector.">Vector4</a>(
<a name="l00257"></a>00257                 lhs.<a class="code" href="classOgre_1_1Vector4.html#c1f14b711795b4d13140e992d9a3e6cf">x</a> + rhs,
<a name="l00258"></a>00258                 lhs.<a class="code" href="classOgre_1_1Vector4.html#4a55a790632b60df0f536efa68de3bfa">y</a> + rhs,
<a name="l00259"></a>00259                 lhs.<a class="code" href="classOgre_1_1Vector4.html#389cf99ed365e8ec1d823c0a0cf52da3">z</a> + rhs,
<a name="l00260"></a>00260                 lhs.<a class="code" href="classOgre_1_1Vector4.html#601896b4f2f5be1d7ccd0ee4a0500237">w</a> + rhs);
<a name="l00261"></a>00261         }
<a name="l00262"></a>00262 
<a name="l00263"></a><a class="code" href="classOgre_1_1Vector4.html#4ec63fee2f096c1e845076797d1e140a">00263</a>         <span class="keyword">inline</span> <span class="keyword">friend</span> <a class="code" href="classOgre_1_1Vector4.html" title="4-dimensional homogenous vector.">Vector4</a> operator + (<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> lhs, <span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector4.html" title="4-dimensional homogenous vector.">Vector4</a>&amp; rhs)
<a name="l00264"></a>00264         {
<a name="l00265"></a>00265             <span class="keywordflow">return</span> <a class="code" href="classOgre_1_1Vector4.html" title="4-dimensional homogenous vector.">Vector4</a>(
<a name="l00266"></a>00266                 lhs + rhs.<a class="code" href="classOgre_1_1Vector4.html#c1f14b711795b4d13140e992d9a3e6cf">x</a>,
<a name="l00267"></a>00267                 lhs + rhs.<a class="code" href="classOgre_1_1Vector4.html#4a55a790632b60df0f536efa68de3bfa">y</a>,
<a name="l00268"></a>00268                 lhs + rhs.<a class="code" href="classOgre_1_1Vector4.html#389cf99ed365e8ec1d823c0a0cf52da3">z</a>,
<a name="l00269"></a>00269                 lhs + rhs.<a class="code" href="classOgre_1_1Vector4.html#601896b4f2f5be1d7ccd0ee4a0500237">w</a>);
<a name="l00270"></a>00270         }
<a name="l00271"></a>00271 
<a name="l00272"></a><a class="code" href="classOgre_1_1Vector4.html#3b9ce3e33b491148161ac0e4116e709a">00272</a>         <span class="keyword">inline</span> <span class="keyword">friend</span> <a class="code" href="classOgre_1_1Vector4.html" title="4-dimensional homogenous vector.">Vector4</a> operator - (<span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector4.html" title="4-dimensional homogenous vector.">Vector4</a>&amp; lhs, <a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> rhs)
<a name="l00273"></a>00273         {
<a name="l00274"></a>00274             <span class="keywordflow">return</span> <a class="code" href="classOgre_1_1Vector4.html" title="4-dimensional homogenous vector.">Vector4</a>(
<a name="l00275"></a>00275                 lhs.<a class="code" href="classOgre_1_1Vector4.html#c1f14b711795b4d13140e992d9a3e6cf">x</a> - rhs,
<a name="l00276"></a>00276                 lhs.<a class="code" href="classOgre_1_1Vector4.html#4a55a790632b60df0f536efa68de3bfa">y</a> - rhs,
<a name="l00277"></a>00277                 lhs.<a class="code" href="classOgre_1_1Vector4.html#389cf99ed365e8ec1d823c0a0cf52da3">z</a> - rhs,
<a name="l00278"></a>00278                 lhs.<a class="code" href="classOgre_1_1Vector4.html#601896b4f2f5be1d7ccd0ee4a0500237">w</a> - rhs);
<a name="l00279"></a>00279         }
<a name="l00280"></a>00280 
<a name="l00281"></a><a class="code" href="classOgre_1_1Vector4.html#e2c5e61fcb0521bdea9c8d70069742f9">00281</a>         <span class="keyword">inline</span> <span class="keyword">friend</span> <a class="code" href="classOgre_1_1Vector4.html" title="4-dimensional homogenous vector.">Vector4</a> operator - (<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> lhs, <span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector4.html" title="4-dimensional homogenous vector.">Vector4</a>&amp; rhs)
<a name="l00282"></a>00282         {
<a name="l00283"></a>00283             <span class="keywordflow">return</span> <a class="code" href="classOgre_1_1Vector4.html" title="4-dimensional homogenous vector.">Vector4</a>(
<a name="l00284"></a>00284                 lhs - rhs.<a class="code" href="classOgre_1_1Vector4.html#c1f14b711795b4d13140e992d9a3e6cf">x</a>,
<a name="l00285"></a>00285                 lhs - rhs.<a class="code" href="classOgre_1_1Vector4.html#4a55a790632b60df0f536efa68de3bfa">y</a>,
<a name="l00286"></a>00286                 lhs - rhs.<a class="code" href="classOgre_1_1Vector4.html#389cf99ed365e8ec1d823c0a0cf52da3">z</a>,
<a name="l00287"></a>00287                 lhs - rhs.<a class="code" href="classOgre_1_1Vector4.html#601896b4f2f5be1d7ccd0ee4a0500237">w</a>);
<a name="l00288"></a>00288         }
<a name="l00289"></a>00289 
<a name="l00290"></a>00290         <span class="comment">// arithmetic updates</span>
<a name="l00291"></a><a class="code" href="classOgre_1_1Vector4.html#da0bb188b87a7187e49e9acfa4994a7f">00291</a>         <span class="keyword">inline</span> <a class="code" href="classOgre_1_1Vector4.html" title="4-dimensional homogenous vector.">Vector4</a>&amp; operator += ( <span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector4.html" title="4-dimensional homogenous vector.">Vector4</a>&amp; rkVector )
<a name="l00292"></a>00292         {
<a name="l00293"></a>00293             x += rkVector.<a class="code" href="classOgre_1_1Vector4.html#c1f14b711795b4d13140e992d9a3e6cf">x</a>;
<a name="l00294"></a>00294             y += rkVector.<a class="code" href="classOgre_1_1Vector4.html#4a55a790632b60df0f536efa68de3bfa">y</a>;
<a name="l00295"></a>00295             z += rkVector.<a class="code" href="classOgre_1_1Vector4.html#389cf99ed365e8ec1d823c0a0cf52da3">z</a>;
<a name="l00296"></a>00296             w += rkVector.<a class="code" href="classOgre_1_1Vector4.html#601896b4f2f5be1d7ccd0ee4a0500237">w</a>;
<a name="l00297"></a>00297 
<a name="l00298"></a>00298             <span class="keywordflow">return</span> *<span class="keyword">this</span>;
<a name="l00299"></a>00299         }
<a name="l00300"></a>00300 
<a name="l00301"></a><a class="code" href="classOgre_1_1Vector4.html#cc233206a14cef454dd0d9428848ebfc">00301</a>         <span class="keyword">inline</span> <a class="code" href="classOgre_1_1Vector4.html" title="4-dimensional homogenous vector.">Vector4</a>&amp; operator -= ( <span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector4.html" title="4-dimensional homogenous vector.">Vector4</a>&amp; rkVector )
<a name="l00302"></a>00302         {
<a name="l00303"></a>00303             x -= rkVector.<a class="code" href="classOgre_1_1Vector4.html#c1f14b711795b4d13140e992d9a3e6cf">x</a>;
<a name="l00304"></a>00304             y -= rkVector.<a class="code" href="classOgre_1_1Vector4.html#4a55a790632b60df0f536efa68de3bfa">y</a>;
<a name="l00305"></a>00305             z -= rkVector.<a class="code" href="classOgre_1_1Vector4.html#389cf99ed365e8ec1d823c0a0cf52da3">z</a>;
<a name="l00306"></a>00306             w -= rkVector.<a class="code" href="classOgre_1_1Vector4.html#601896b4f2f5be1d7ccd0ee4a0500237">w</a>;
<a name="l00307"></a>00307 
<a name="l00308"></a>00308             <span class="keywordflow">return</span> *<span class="keyword">this</span>;
<a name="l00309"></a>00309         }
<a name="l00310"></a>00310 
<a name="l00311"></a><a class="code" href="classOgre_1_1Vector4.html#df84c66492823f9c7a609133cf7ebfb1">00311</a>         <span class="keyword">inline</span> <a class="code" href="classOgre_1_1Vector4.html" title="4-dimensional homogenous vector.">Vector4</a>&amp; operator *= ( <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> fScalar )
<a name="l00312"></a>00312         {
<a name="l00313"></a>00313             x *= fScalar;
<a name="l00314"></a>00314             y *= fScalar;
<a name="l00315"></a>00315             z *= fScalar;
<a name="l00316"></a>00316             w *= fScalar;
<a name="l00317"></a>00317             <span class="keywordflow">return</span> *<span class="keyword">this</span>;
<a name="l00318"></a>00318         }
<a name="l00319"></a>00319 
<a name="l00320"></a><a class="code" href="classOgre_1_1Vector4.html#37efa8bb4db9148fb43c8238b21c1906">00320</a>         <span class="keyword">inline</span> <a class="code" href="classOgre_1_1Vector4.html" title="4-dimensional homogenous vector.">Vector4</a>&amp; operator += ( <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> fScalar )
<a name="l00321"></a>00321         {
<a name="l00322"></a>00322             x += fScalar;
<a name="l00323"></a>00323             y += fScalar;
<a name="l00324"></a>00324             z += fScalar;
<a name="l00325"></a>00325             w += fScalar;
<a name="l00326"></a>00326             <span class="keywordflow">return</span> *<span class="keyword">this</span>;
<a name="l00327"></a>00327         }
<a name="l00328"></a>00328 
<a name="l00329"></a><a class="code" href="classOgre_1_1Vector4.html#8a23c96373a8d8163ea5b7819f2b22f3">00329</a>         <span class="keyword">inline</span> <a class="code" href="classOgre_1_1Vector4.html" title="4-dimensional homogenous vector.">Vector4</a>&amp; operator -= ( <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> fScalar )
<a name="l00330"></a>00330         {
<a name="l00331"></a>00331             x -= fScalar;
<a name="l00332"></a>00332             y -= fScalar;
<a name="l00333"></a>00333             z -= fScalar;
<a name="l00334"></a>00334             w -= fScalar;
<a name="l00335"></a>00335             <span class="keywordflow">return</span> *<span class="keyword">this</span>;
<a name="l00336"></a>00336         }
<a name="l00337"></a>00337 
<a name="l00338"></a><a class="code" href="classOgre_1_1Vector4.html#ed2924604df2a820a6208a85522c0eed">00338</a>         <span class="keyword">inline</span> <a class="code" href="classOgre_1_1Vector4.html" title="4-dimensional homogenous vector.">Vector4</a>&amp; operator *= ( <span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector4.html" title="4-dimensional homogenous vector.">Vector4</a>&amp; rkVector )
<a name="l00339"></a>00339         {
<a name="l00340"></a>00340             x *= rkVector.<a class="code" href="classOgre_1_1Vector4.html#c1f14b711795b4d13140e992d9a3e6cf">x</a>;
<a name="l00341"></a>00341             y *= rkVector.<a class="code" href="classOgre_1_1Vector4.html#4a55a790632b60df0f536efa68de3bfa">y</a>;
<a name="l00342"></a>00342             z *= rkVector.<a class="code" href="classOgre_1_1Vector4.html#389cf99ed365e8ec1d823c0a0cf52da3">z</a>;
<a name="l00343"></a>00343             w *= rkVector.<a class="code" href="classOgre_1_1Vector4.html#601896b4f2f5be1d7ccd0ee4a0500237">w</a>;
<a name="l00344"></a>00344 
<a name="l00345"></a>00345             <span class="keywordflow">return</span> *<span class="keyword">this</span>;
<a name="l00346"></a>00346         }
<a name="l00347"></a>00347 
<a name="l00348"></a><a class="code" href="classOgre_1_1Vector4.html#0c4b23241a97373da79afc6c993e1370">00348</a>         <span class="keyword">inline</span> <a class="code" href="classOgre_1_1Vector4.html" title="4-dimensional homogenous vector.">Vector4</a>&amp; operator /= ( <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> fScalar )
<a name="l00349"></a>00349         {
<a name="l00350"></a>00350             assert( fScalar != 0.0 );
<a name="l00351"></a>00351 
<a name="l00352"></a>00352             <a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> fInv = 1.0 / fScalar;
<a name="l00353"></a>00353 
<a name="l00354"></a>00354             x *= fInv;
<a name="l00355"></a>00355             y *= fInv;
<a name="l00356"></a>00356             z *= fInv;
<a name="l00357"></a>00357             w *= fInv;
<a name="l00358"></a>00358 
<a name="l00359"></a>00359             <span class="keywordflow">return</span> *<span class="keyword">this</span>;
<a name="l00360"></a>00360         }
<a name="l00361"></a>00361 
<a name="l00362"></a><a class="code" href="classOgre_1_1Vector4.html#4c4def28bfaf96a3326747d2ef2ed08f">00362</a>         <span class="keyword">inline</span> <a class="code" href="classOgre_1_1Vector4.html" title="4-dimensional homogenous vector.">Vector4</a>&amp; operator /= ( <span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector4.html" title="4-dimensional homogenous vector.">Vector4</a>&amp; rkVector )
<a name="l00363"></a>00363         {
<a name="l00364"></a>00364             x /= rkVector.<a class="code" href="classOgre_1_1Vector4.html#c1f14b711795b4d13140e992d9a3e6cf">x</a>;
<a name="l00365"></a>00365             y /= rkVector.<a class="code" href="classOgre_1_1Vector4.html#4a55a790632b60df0f536efa68de3bfa">y</a>;
<a name="l00366"></a>00366             z /= rkVector.<a class="code" href="classOgre_1_1Vector4.html#389cf99ed365e8ec1d823c0a0cf52da3">z</a>;
<a name="l00367"></a>00367             w /= rkVector.<a class="code" href="classOgre_1_1Vector4.html#601896b4f2f5be1d7ccd0ee4a0500237">w</a>;
<a name="l00368"></a>00368 
<a name="l00369"></a>00369             <span class="keywordflow">return</span> *<span class="keyword">this</span>;
<a name="l00370"></a>00370         }
<a name="l00371"></a>00371 
<a name="l00379"></a><a class="code" href="classOgre_1_1Vector4.html#14ced50f2a18dd194c3d95d7d031c5dd">00379</a>         <span class="keyword">inline</span> <a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> dotProduct(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector4.html" title="4-dimensional homogenous vector.">Vector4</a>&amp; vec)<span class="keyword"> const</span>
<a name="l00380"></a>00380 <span class="keyword">        </span>{
<a name="l00381"></a>00381             <span class="keywordflow">return</span> x * vec.<a class="code" href="classOgre_1_1Vector4.html#c1f14b711795b4d13140e992d9a3e6cf">x</a> + y * vec.<a class="code" href="classOgre_1_1Vector4.html#4a55a790632b60df0f536efa68de3bfa">y</a> + z * vec.<a class="code" href="classOgre_1_1Vector4.html#389cf99ed365e8ec1d823c0a0cf52da3">z</a> + w * vec.<a class="code" href="classOgre_1_1Vector4.html#601896b4f2f5be1d7ccd0ee4a0500237">w</a>;
<a name="l00382"></a>00382         }
<a name="l00385"></a>00385         <span class="keyword">inline</span> <a class="code" href="OgrePlatform_8h.html#20566b1253bae200372ed9162489a663">_OgreExport</a> <span class="keyword">friend</span> std::ostream&amp; <span class="keyword">operator</span> &lt;&lt;
<a name="l00386"></a><a class="code" href="classOgre_1_1Vector4.html#7f9291e487a6dd6abdc8cc6325751cc3">00386</a>             ( std::ostream&amp; o, <span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector4.html" title="4-dimensional homogenous vector.">Vector4</a>&amp; v )
<a name="l00387"></a>00387         {
<a name="l00388"></a>00388             o &lt;&lt; <span class="stringliteral">"Vector4("</span> &lt;&lt; v.x &lt;&lt; <span class="stringliteral">", "</span> &lt;&lt; v.y &lt;&lt; <span class="stringliteral">", "</span> &lt;&lt; v.z &lt;&lt; <span class="stringliteral">", "</span> &lt;&lt; v.w &lt;&lt; <span class="stringliteral">")"</span>;
<a name="l00389"></a>00389             <span class="keywordflow">return</span> o;
<a name="l00390"></a>00390         }
<a name="l00391"></a>00391         <span class="comment">// special</span>
<a name="l00392"></a><a class="code" href="classOgre_1_1Vector4.html#6094638aa9e67551258f70f113d805d9">00392</a>         <span class="keyword">static</span> <span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector4.html" title="4-dimensional homogenous vector.">Vector4</a> ZERO;
<a name="l00393"></a>00393     };
<a name="l00394"></a>00394 
<a name="l00395"></a>00395 }
<a name="l00396"></a>00396 <span class="preprocessor">#endif</span>
</pre></div><hr>
<p>
Copyright &copy; 2000-2005 by The OGRE Team<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/2.5/"><img alt="Creative Commons License" border="0" src="http://creativecommons.org/images/public/somerights20.png"/></a><br/>
This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/2.5/">Creative Commons Attribution-ShareAlike 2.5 License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Mon Jun 16 12:48:57 2008
</p>
</body>
</html>
